import { ActionBar } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/ui/actionbar/actionbar";
import { IHighlight } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/ui/highlightedlabel/highlightedLabel";
import { ITreeNode } from "@codingame/monaco-vscode-api/vscode/vs/base/browser/ui/tree/tree";
import { FuzzyScore } from "@codingame/monaco-vscode-api/vscode/vs/base/common/filters";
import { IMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/actions/common/actions.service";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { IContextKeyService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextkey/common/contextkey.service";
import { IContextMenuService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextview/browser/contextView.service";
import { IContextViewService } from "@codingame/monaco-vscode-api/vscode/vs/platform/contextview/browser/contextView.service";
import { IHoverService } from "@codingame/monaco-vscode-api/vscode/vs/platform/hover/browser/hover.service";
import { IInstantiationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/instantiation/common/instantiation";
import { IKeybindingService } from "@codingame/monaco-vscode-api/vscode/vs/platform/keybinding/common/keybinding.service";
import { IOpenerService } from "@codingame/monaco-vscode-api/vscode/vs/platform/opener/common/opener.service";
import { IThemeService } from "@codingame/monaco-vscode-api/vscode/vs/platform/theme/common/themeService.service";
import { ViewPane } from "@codingame/monaco-vscode-65619f8f-0eab-5d8b-855a-43b6353fe527-common/vscode/vs/workbench/browser/parts/views/viewPane";
import { IViewletViewOptions } from "@codingame/monaco-vscode-2a94c04a-b85b-5669-b06b-89c1bfa11cb9-common/vscode/vs/workbench/browser/parts/views/viewsViewlet";
import { IViewDescriptorService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/views.service";
import { IDebugViewWithVariables, IExpression } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
import { AbstractExpressionsRenderer, IExpressionTemplateData, IInputBoxOptions } from "@codingame/monaco-vscode-88aa9a78-75f5-5aaa-89e9-bbdd580b3b5c-common/vscode/vs/workbench/contrib/debug/browser/baseDebugView";
import { DebugExpressionRenderer } from "@codingame/monaco-vscode-88aa9a78-75f5-5aaa-89e9-bbdd580b3b5c-common/vscode/vs/workbench/contrib/debug/browser/debugExpressionRenderer";
export declare class WatchExpressionsView extends ViewPane implements IDebugViewWithVariables {
    private readonly debugService;
    private watchExpressionsUpdatedScheduler;
    private needsRefresh;
    private tree;
    private watchExpressionsExist;
    private watchItemType;
    private variableReadonly;
    private menu;
    private expressionRenderer;
    get treeSelection(): IExpression[];
    constructor(options: IViewletViewOptions, contextMenuService: IContextMenuService, debugService: IDebugService, keybindingService: IKeybindingService, instantiationService: IInstantiationService, viewDescriptorService: IViewDescriptorService, configurationService: IConfigurationService, contextKeyService: IContextKeyService, openerService: IOpenerService, themeService: IThemeService, hoverService: IHoverService, menuService: IMenuService);
    protected renderBody(container: HTMLElement): void;
    protected layoutBody(height: number, width: number): void;
    focus(): void;
    collapseAll(): void;
    private onMouseDblClick;
    private onContextMenu;
}
export declare class WatchExpressionsRenderer extends AbstractExpressionsRenderer {
    private readonly expressionRenderer;
    private readonly menuService;
    private readonly contextKeyService;
    private configurationService;
    static readonly ID = "watchexpression";
    constructor(expressionRenderer: DebugExpressionRenderer, menuService: IMenuService, contextKeyService: IContextKeyService, debugService: IDebugService, contextViewService: IContextViewService, hoverService: IHoverService, configurationService: IConfigurationService);
    get templateId(): string;
    renderElement(node: ITreeNode<IExpression, FuzzyScore>, index: number, data: IExpressionTemplateData): void;
    protected renderExpression(expression: IExpression, data: IExpressionTemplateData, highlights: IHighlight[]): void;
    protected getInputBoxOptions(expression: IExpression, settingValue: boolean): IInputBoxOptions;
    protected renderActionBar(actionBar: ActionBar, expression: IExpression): void;
}
export declare const ADD_WATCH_ID = "workbench.debug.viewlet.action.addWatchExpression";
export declare const ADD_WATCH_LABEL: string;
export declare const REMOVE_WATCH_EXPRESSIONS_COMMAND_ID = "workbench.debug.viewlet.action.removeAllWatchExpressions";
export declare const REMOVE_WATCH_EXPRESSIONS_LABEL: string;
