import { URI as uri } from "@codingame/monaco-vscode-api/vscode/vs/base/common/uri";
import { ITextModel } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/model";
import { IModelService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/services/model.service";
import { ILanguageService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/languages/language.service";
import { ITextModelContentProvider } from "@codingame/monaco-vscode-model-service-override/vscode/vs/editor/common/services/resolverService";
import { ITextModelService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/services/resolverService.service";
import { IWorkbenchContribution } from "@codingame/monaco-vscode-api/vscode/vs/workbench/common/contributions";
import { IDebugService } from "@codingame/monaco-vscode-api/vscode/vs/workbench/contrib/debug/common/debug.service";
import { IEditorWorkerService } from "@codingame/monaco-vscode-api/vscode/vs/editor/common/services/editorWorker.service";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
export declare class DebugContentProvider extends Disposable implements IWorkbenchContribution, ITextModelContentProvider {
    private readonly debugService;
    private readonly modelService;
    private readonly languageService;
    private readonly editorWorkerService;
    private static INSTANCE;
    private readonly pendingUpdates;
    constructor(textModelResolverService: ITextModelService, debugService: IDebugService, modelService: IModelService, languageService: ILanguageService, editorWorkerService: IEditorWorkerService);
    dispose(): void;
    provideTextContent(resource: uri): Promise<ITextModel> | null;
    static refreshDebugContent(resource: uri): void;
    private createOrUpdateContentModel;
}
